الإبلاغ عن أخطاء

الإبلاغ عن الأخطاء تلقائيًا

يمكنك نشر خطأ من إحدى دوال السحابة الإلكترونية إلى الإبلاغ عن الأخطاء كما هو موضّح أدناه:

Node.js

// These WILL be reported to Error Reporting
throw new Error('I failed you'); // Will cause a cold start if not caught

Python

@functions_framework.http
def hello_error_1(request):
    # This WILL be reported to Error Reporting,
    # and WILL NOT show up in logs or
    # terminate the function.
    from google.cloud import error_reporting

    client = error_reporting.Client()

    try:
        raise RuntimeError("I failed you")
    except RuntimeError:
        client.report_exception()

    # This WILL be reported to Error Reporting,
    # and WILL terminate the function
    raise RuntimeError("I failed you")


@functions_framework.http
def hello_error_2(request):
    # These errors WILL NOT be reported to Error
    # Reporting, but will show up in logs.
    import logging
    import sys

    print(RuntimeError("I failed you (print to stdout)"))
    logging.warning(RuntimeError("I failed you (logging.warning)"))
    logging.error(RuntimeError("I failed you (logging.error)"))
    sys.stderr.write("I failed you (sys.stderr.write)\n")

    # This is considered a successful execution and WILL NOT be reported
    # to Error Reporting, but the status code (500) WILL be logged.
    from flask import abort

    return abort(500)

وإذا أردت الحصول على تقارير أكثر دقة عن الأخطاء، يمكنك استخدام مكتبات عميل إعداد تقارير الأخطاء.

يمكنك الاطّلاع على الأخطاء التي تم الإبلاغ عنها من خلال قسم الإبلاغ عن الأخطاء في وحدة تحكُّم Google Cloud Platform. يمكنك أيضًا الاطّلاع على الأخطاء التي تم الإبلاغ عنها من دالة معيّنة عند اختيارها من قائمة الدوال في "وحدة تحكُّم Google Cloud Platform".

ستظهر الاستثناءات غير المكتشفة التي أنشأتها الدالة في "إعداد تقارير الأخطاء". تجدر الإشارة إلى أن بعض أنواع الاستثناءات غير المرصودة (مثل الاستثناءات التي يتم طرحها بشكل غير متزامن) ستؤدي إلى حدوث بداية باردة عند استدعاء دالة في المستقبل. يؤدي هذا إلى زيادة مقدار الوقت الذي سيستغرقه تشغيل الدالة.

الإبلاغ عن الأخطاء يدويًا

الإرسال إلى Cloud Logging

ستُبلِغ الدالة error من حزمة logger لخدمة Cloud Functions عن الأخطاء لكل من Cloud Logging وError Reporting. لتضمين مزيد من السياق من الخطأ كـ بيانات منظَّمة، مرِّر كائن الخطأ كوسيطة ثانية:

} catch (err) {
  // Attach an error object as the second argument
  functions.logger.error(
    "Unable to read quote from Firestore, sending default instead",
    err
  );
}